"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const validator_1 = __importDefault(require("./validator"));
/**
 * Validates that an element contains only numbers.
 */
class NumberValidator extends validator_1.default {
    constructor() {
        super();
        this.numberRegex = new RegExp(/^\d*$/);
    }
    ;
    /**
     * Tool tip that will be used for web interfaces
     */
    toolTip() {
        return "Checks if number";
    }
    ;
    /**
     * Validate an individual item. Return true, or information about a failed validation
     *
     * @param element Element that we are validating
     * @returns true, or rejection that includes the original element, and an array of errors for it
     */
    validate(element) {
        let errors = [];
        if (this.numberRegex.test(element) == false) {
            errors.push('Not a number');
        }
        ;
        return new Promise((resolve, reject) => {
            if (errors.length > 0) {
                reject({
                    originalElement: element,
                    errors: errors
                });
            }
            else {
                resolve(true);
            }
            ;
        });
    }
    ;
}
;
exports.default = NumberValidator;
