import Validator from './validator';
/**
 * RingCentral password. Used to log into any RC software or the web interface. Not needed if a customer account enforces SSO.
 *
 * https://support.ringcentral.com/article/5766.html
 */
declare class PasswordValidator extends Validator {
    atLeastOneLetterRegex: RegExp;
    atLeastOneNumberRegex: RegExp;
    atLeastOneUpperOrSpecialRegex: RegExp;
    sequentialNumbersRegex: RegExp;
    repeatingNumbersRegex: RegExp;
    sequentialLettersRegex: RegExp;
    repeatingLettersRegex: RegExp;
    constructor();
    toolTip(): string;
    validate(element: string): Promise<boolean>;
    createRepeatedNumbersRegex(): RegExp;
    createSequentialNumbersRegex(): RegExp;
    createRepeatedLettersRegex(): RegExp;
    createSequentialLettersRegex(): RegExp;
}
export default PasswordValidator;
//# sourceMappingURL=password.d.ts.map